
%{

#if 0
}
#endif


typedef int (*getcharf)(void* parm);
typedef void (*ungetcharf)(void* parm, int c);

typedef struct {
    model* ret;
    getcharf getc;
    ungetcharf ungetc;
    int cqual;
    void* getcparm;
} yyparm_t;

#define yyparm ((yyparm_t*)parm)

#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm
#define YYERROR_VERBOSE 1

int filegetc(void* dat) {
    return fgetc((FILE*)dat);
}
void fileungetc(void* dat, int c) {
    ungetc(c,(FILE*)dat);
}
int strgetc(void* dat) {
    if (!*(char*)dat) return EOF;
    return *((char*)dat)++;
}
void strungetc(void* dat, int c) {
    *(--(char*)dat)=c;
}

#define NEW(type) ((type*)malloc(sizeof(type)))
#define NEWARR(type,size) ((type*)malloc(sizeof(type)*(size)))
#define RESIZEARR(arr,size) (arr=(typeof(arr))realloc(arr,sizeof(*arr)*(size)))


static skintex* LoadSkin(const char* fname);

void shape_addvt(m_shape* shap, const m_vertex* vert, const m_texcoord* tc) {
    if (shap->nverts && !(shap->nverts&7)) {
	RESIZEARR(shap->verts,shap->nverts+8);
	RESIZEARR(shap->texcoords,shap->nverts+8);
    }
    shap->verts[shap->nverts]=*vert;
    shap->texcoords[shap->nverts]=*tc;
    shap->nverts++;
}
void shape_addvc(m_shape* shap, const m_vertex* vert, const m_color* col) {
    if (shap->nverts && !(shap->nverts&7)) {
	RESIZEARR(shap->verts,shap->nverts+8);
	RESIZEARR(shap->colors,shap->nverts+8);
    }
    shap->verts[shap->nverts]=*vert;
    shap->colors[shap->nverts]=*col;
    shap->nverts++;
}
void shape_addvtc(m_shape* shap, const m_vertex* vert, const m_texcoord* tc, const m_color* col) {
    if (shap->nverts && !(shap->nverts&7)) {
	RESIZEARR(shap->verts,shap->nverts+8);
	RESIZEARR(shap->colors,shap->nverts+8);
	RESIZEARR(shap->texcoords,shap->nverts+8);
    }
    shap->verts[shap->nverts]=*vert;
    shap->texcoords[shap->nverts]=*tc;
    shap->colors[shap->nverts]=*col;
    shap->nverts++;
}
void shapelist_addshape(shape_list* mod, const m_shape* shape) {
    if (mod->nshapes&& !(mod->nshapes&7)) {
	RESIZEARR(mod->shapes,mod->nshapes+8);
    }
    mod->shapes[mod->nshapes]=*shape;
    mod->nshapes++;
}

#if 0 
{
#endif
%}

%union {
    m_vertex vertex;
    m_color color;
    m_texcoord coord;
    m_shape shap;
    shape_list shaplist;
    model* mod;
    char* sval;
    int ival;
    double dval;
}

%{
    int yylex (YYSTYPE* lval, void* parm);
    void yyerror (const char* str);
    
%}

%pure_parser


%token <sval> STRING
%token <sval> SYMBOL
%token <ival> INTEGER
%token <dval> FLOAT
%token <ival> T_TYPE


%type <vertex> vertex
%type <color> color
%type <coord> texcoord

%type <shap> shapelist_tex
%type <shap> shapelist_col
%type <shap> shapelist_texcol
%type <shap> shape_tex
%type <shap> shape_col
%type <shap> shape_texcol
%type <shap> shape
%type <shaplist> shapelist
%type <mod> input

%token T_TEX
%token T_COL
%token T_QUAL




%%
	input: qualsec { }
	;
	qualsec: /* empty */ { }
		| qualsec T_QUAL FLOAT '{' shapelist '}' { yyparm->ret->shapes[(int)$3]=$5; }
	;
	shapelist: /* empty */ { $$.nshapes=0; $$.shapes=NEWARR(m_shape,8); }
		| shapelist shape { $$=$1; shapelist_addshape(&$$,&$2); }
	;
	shape: shape_tex
	     | shape_col
	     | shape_texcol
	;
	

	shape_tex: T_TYPE T_TEX STRING vertex '{' shapelist_tex '}' { $$=$6; $$.normal=$4; $$.type=$1; $$.tex=LoadSkin($3)->tex; }
	;

	shape_col: T_TYPE T_COL vertex '{' shapelist_col '}' { $$=$5; $$.normal=$3; $$.type=$1; }
	;

	shape_texcol: T_TYPE T_TEX STRING T_COL vertex '{' shapelist_texcol '}' { $$=$7; $$.normal=$5; $$.type=$1; $$.tex=LoadSkin($3)->tex; }
	;

	shapelist_tex: /* empty */ { $$.nverts=0; $$.colors=NULL; $$.verts=NEWARR(m_vertex,8); $$.texcoords=NEWARR(m_texcoord,8); }
		| shapelist_tex vertex texcoord { $$=$1; shape_addvt(&$$,&$2,&$3); }
	;
	
	shapelist_col: /* empty */ { $$.nverts=0; $$.verts=NEWARR(m_vertex,8); $$.colors=NEWARR(m_color,8); $$.texcoords=NULL; }
		| shapelist_col vertex color { $$=$1; shape_addvc(&$$,&$2,&$3); }
	;

	shapelist_texcol: /* empty */ { $$.nverts=0; $$.verts=NEWARR(m_vertex,8); $$.texcoords=NEWARR(m_texcoord,8); $$.colors=NEWARR(m_color,8); }
		|shapelist_texcol vertex texcoord color { $$=$1; shape_addvtc(&$$,&$2,&$3,&$4); }
	;

	vertex: '<' FLOAT FLOAT FLOAT '>' { $$.x=$2; $$.y=$3; $$.z=$4; } ;
	color: '<' FLOAT FLOAT FLOAT '>' { $$.r=$2; $$.g=$3; $$.b=$4; } ;
	texcoord: '<' FLOAT FLOAT '>' { $$.x=$2; $$.y=$3; } ;

%%

#if 0
	 ;;;;;;;;;;;
#endif

#define yygetc (yyparm->getc)(yyparm->getcparm)
#define yyungetc(c) (yyparm->ungetc)(yyparm->getcparm,c)


#define ESCEXT 					\
if (c== '\\') {					\
    c=yygetc;					\
    switch (c) {				\
    case 'n': c='\n'; break;			\
    case 't': c='\t'; break;			\
    case 'b': c='\b'; break;			\
    }						\
}
#define NOEXT




#define READSTRING(strname,termcond,ext) 				\
	    char *strname = 0;						\
	    int length = 40;						\
	    int i;							\
	    strname = (char*)malloc(length+1);				\
	    i = 0;							\
	    do {							\
		if (i == length) {					\
		    length *= 2;					\
		    strname=(char*)realloc(strname, length+1);		\
		}							\
		ext							\
		strname[i++] = c;					\
		c=yygetc;						\
	    } while (termcond);						\
	    strname[i] = '\0'




int issymtoken(int c) {
    return !(c==' '||c=='\t'||c=='\n'||c=='('||c==')'||c=='['||c==']'||c=='{'||c=='}'||c=='"'||c=='\''||c==EOF);
}

typedef struct {
    char* ident;
    int id;
} symrec;

typedef struct {
    char* ident;
    int type;
} typerec;

symrec ops[]= {
    { "tex", T_TEX },
    { "color", T_COL },
    { "qual", T_QUAL },
    { NULL, 0 }
};
typerec types[]= {
    { "quad", ST_QUAD },
    { "quadstrip", ST_QUADSTRIP },
    { "tri", ST_TRI },
    { "tristrip", ST_TRISTRIP },
    { "trifan", ST_TRIFAN },
    { "poly", ST_POLY },
    { NULL, 0 }
};

void yyerror(const char* error) {
    fprintf(stderr,"Bison error:%s\n",error);
    SDL_Quit();
    exit(-1);
}
#if 0
int _d_yylex (YYSTYPE* lval, void* parm);

int yylex (YYSTYPE* lval, void* parm) {
    int ret=_d_yylex(lval,parm);
    switch (ret) {
    case FLOAT:
	printf("yylex returning float %f\n",lval->dval);
	break;
    case STRING:
	printf("yylex returning string %s\n",lval->sval);
	break;
    case SYMBOL:
	printf("yylex returning symbol %s\n",lval->sval);
	break;
    case T_TYPE:
	printf("yylex returning type %s\n",types[lval->ival].ident);
	break;
    default:
	printf("yylex returning '%c'\n",ret);
	break;
    }
    return ret;
}

#define yylex _d_yylex
#endif

int yylex (YYSTYPE* lval, void* parm) {
    int c;
    do {
	while ((c = yygetc) == ' ' || c == '\t' || c == '\n');
	if (c == '#') {
	    while ((c = yygetc) != '\n' && c != EOF);
	    continue;
	}
	break;
    } while (1);
    if (c == 0) {
	return 0;
    }
    if (c == '-' || c == '.' || isdigit (c)) {
	long long val=0;
	int div=1;
	if (c == '-') {
	    div=-1;
	} else {
	    yyungetc(c);
	}
	    int seendot=0;
	while (isdigit(c=yygetc) || (!seendot && c=='.')) {
	    if (c=='.') {
		seendot=1;
		continue;
	    }
	    if (seendot) {
		div *= 10;
	    }
		val *= 10;
		val += (c-'0');
	}
	yyungetc(c);
	lval->dval = ((double)val)/div;
	return FLOAT;
    }
    if (c == '"') {
	c=yygetc;
	READSTRING(strbuf,c != EOF && c != '"',ESCEXT);
	lval->sval = strbuf;
	return STRING;
    }
    if (isalpha(c) || c == '_') {
	READSTRING(symbuf,c != EOF && (isalnum(c) || c == '_'),NOEXT);
	yyungetc(c);
	symrec* sr = ops;
	while (sr->ident) {
	    if (!strcmp(symbuf,sr->ident)) {
		free(symbuf);
		return sr->id;
	    }
	    sr++;
	}
	typerec* tr = types;
	while (tr->ident) {
	    if (!strcmp(symbuf,tr->ident)) {
		free(symbuf);
		lval->ival=tr->type;
		return T_TYPE;
	    }
	    tr++;
	}
	lval->sval = symbuf;
	return SYMBOL;
    }
    return c;
}
